<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>JavaGenUtils xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../../../apidocs/org/eclipse/papyrus/designer/languages/java/codegen/utils/JavaGenUtils.html">View Javadoc</a></div><pre>
<a class="jxr_linenumber" name="L1" href="#L1">1</a>   <em class="jxr_javadoccomment">/*******************************************************************************</em>
<a class="jxr_linenumber" name="L2" href="#L2">2</a>   <em class="jxr_javadoccomment"> * Copyright (c) 2006 - 2016 CEA LIST.</em>
<a class="jxr_linenumber" name="L3" href="#L3">3</a>   <em class="jxr_javadoccomment"> * All rights reserved. This program and the accompanying materials</em>
<a class="jxr_linenumber" name="L4" href="#L4">4</a>   <em class="jxr_javadoccomment"> * are made available under the terms of the Eclipse Public License v1.0</em>
<a class="jxr_linenumber" name="L5" href="#L5">5</a>   <em class="jxr_javadoccomment"> * which accompanies this distribution, and is available at</em>
<a class="jxr_linenumber" name="L6" href="#L6">6</a>   <em class="jxr_javadoccomment"> * <a href="http://www.eclipse.org/legal/epl-v10.htm" target="alexandria_uri">http://www.eclipse.org/legal/epl-v10.htm</a>l</em>
<a class="jxr_linenumber" name="L7" href="#L7">7</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L8" href="#L8">8</a>   <em class="jxr_javadoccomment"> * Contributors:</em>
<a class="jxr_linenumber" name="L9" href="#L9">9</a>   <em class="jxr_javadoccomment"> *     Shuai Li (CEA LIST) &lt;shuai.li@cea.fr&gt; - initial API and implementation</em>
<a class="jxr_linenumber" name="L10" href="#L10">10</a>  <em class="jxr_javadoccomment"> *******************************************************************************/</em>
<a class="jxr_linenumber" name="L11" href="#L11">11</a>  
<a class="jxr_linenumber" name="L12" href="#L12">12</a>  <strong class="jxr_keyword">package</strong> org.eclipse.papyrus.designer.languages.java.codegen.utils;
<a class="jxr_linenumber" name="L13" href="#L13">13</a>  
<a class="jxr_linenumber" name="L14" href="#L14">14</a>  <strong class="jxr_keyword">import</strong> java.util.HashMap;
<a class="jxr_linenumber" name="L15" href="#L15">15</a>  <strong class="jxr_keyword">import</strong> java.util.Map;
<a class="jxr_linenumber" name="L16" href="#L16">16</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.common.util.EList;
<a class="jxr_linenumber" name="L17" href="#L17">17</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.common.base.GenUtils;
<a class="jxr_linenumber" name="L18" href="#L18">18</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.java.profile.PapyrusJava.ExternLibrary;
<a class="jxr_linenumber" name="L19" href="#L19">19</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.java.profile.PapyrusJava.External;
<a class="jxr_linenumber" name="L20" href="#L20">20</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.java.profile.PapyrusJava.NoCodeGen;
<a class="jxr_linenumber" name="L21" href="#L21">21</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Classifier;
<a class="jxr_linenumber" name="L22" href="#L22">22</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.ClassifierTemplateParameter;
<a class="jxr_linenumber" name="L23" href="#L23">23</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Element;
<a class="jxr_linenumber" name="L24" href="#L24">24</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Enumeration;
<a class="jxr_linenumber" name="L25" href="#L25">25</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Interface;
<a class="jxr_linenumber" name="L26" href="#L26">26</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.NamedElement;
<a class="jxr_linenumber" name="L27" href="#L27">27</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Namespace;
<a class="jxr_linenumber" name="L28" href="#L28">28</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Package;
<a class="jxr_linenumber" name="L29" href="#L29">29</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.ParameterableElement;
<a class="jxr_linenumber" name="L30" href="#L30">30</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.PrimitiveType;
<a class="jxr_linenumber" name="L31" href="#L31">31</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.TemplateParameter;
<a class="jxr_linenumber" name="L32" href="#L32">32</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.UMLFactory;
<a class="jxr_linenumber" name="L33" href="#L33">33</a>  
<a class="jxr_linenumber" name="L34" href="#L34">34</a>  <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L35" href="#L35">35</a>  <em class="jxr_javadoccomment"> * Some utilities specific to Java code generation</em>
<a class="jxr_linenumber" name="L36" href="#L36">36</a>  <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="L37" href="#L37">37</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/languages/java/codegen/utils/JavaGenUtils.html">JavaGenUtils</a> {
<a class="jxr_linenumber" name="L38" href="#L38">38</a>  
<a class="jxr_linenumber" name="L39" href="#L39">39</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String JAVA_LIB = <span class="jxr_string">"JavaLibrary"</span>; <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L40" href="#L40">40</a>  	
<a class="jxr_linenumber" name="L41" href="#L41">41</a>  	<strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> NamedElement currentNE;
<a class="jxr_linenumber" name="L42" href="#L42">42</a>  	<strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> Namespace currentNS;
<a class="jxr_linenumber" name="L43" href="#L43">43</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> Map&lt;NamedElement, EList&lt;String&gt;&gt; imports = <strong class="jxr_keyword">new</strong> HashMap&lt;NamedElement, EList&lt;String&gt;&gt;();
<a class="jxr_linenumber" name="L44" href="#L44">44</a>  
<a class="jxr_linenumber" name="L45" href="#L45">45</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L46" href="#L46">46</a>  <em class="jxr_javadoccomment">	 * The standard UML, MARTE, and JavaPrimitive libraries provide some primitives to be translated as Java primitives</em>
<a class="jxr_linenumber" name="L47" href="#L47">47</a>  <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L48" href="#L48">48</a>  <em class="jxr_javadoccomment">	 * @param type</em>
<a class="jxr_linenumber" name="L49" href="#L49">49</a>  <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L50" href="#L50">50</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L51" href="#L51">51</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> String getStdtypes(PrimitiveType type) {
<a class="jxr_linenumber" name="L52" href="#L52">52</a>  		Object owner = type.getOwner();
<a class="jxr_linenumber" name="L53" href="#L53">53</a>  		String owningPkgName = <span class="jxr_string">""</span>; <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L54" href="#L54">54</a>  		<strong class="jxr_keyword">if</strong> (owner instanceof Package) {
<a class="jxr_linenumber" name="L55" href="#L55">55</a>  			owningPkgName = ((Package) owner).getName();
<a class="jxr_linenumber" name="L56" href="#L56">56</a>  		}
<a class="jxr_linenumber" name="L57" href="#L57">57</a>  		<strong class="jxr_keyword">if</strong> (owningPkgName.equals(<span class="jxr_string">"PrimitiveTypes"</span>) || <em class="jxr_comment">// used in UML &gt;= 2.4 //$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L58" href="#L58">58</a>  				owningPkgName.equals(<span class="jxr_string">"UMLPrimitiveTypes"</span>) || <em class="jxr_comment">// used in UML &lt; 2.4 //$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L59" href="#L59">59</a>  				owningPkgName.equals(<span class="jxr_string">"MARTE_PrimitivesTypes"</span>) ||
<a class="jxr_linenumber" name="L60" href="#L60">60</a>  				owningPkgName.equals(<span class="jxr_string">"JavaPrimitiveTypes"</span>)) { <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L61" href="#L61">61</a>  			String td = <span class="jxr_string">""</span>;
<a class="jxr_linenumber" name="L62" href="#L62">62</a>  			String name = type.getName();
<a class="jxr_linenumber" name="L63" href="#L63">63</a>  
<a class="jxr_linenumber" name="L64" href="#L64">64</a>  			<strong class="jxr_keyword">if</strong> (name.equalsIgnoreCase(<span class="jxr_string">"Integer"</span>)) { <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L65" href="#L65">65</a>  				td = <span class="jxr_string">"int"</span>; <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L66" href="#L66">66</a>  			} <strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (name.equalsIgnoreCase(<span class="jxr_string">"Unlimited Natural"</span>)) { <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L67" href="#L67">67</a>  				td = <span class="jxr_string">"long"</span>; <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L68" href="#L68">68</a>  			} <strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (name.equalsIgnoreCase(<span class="jxr_string">"Real"</span>)) { <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L69" href="#L69">69</a>  				td = <span class="jxr_string">"float"</span>; <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L70" href="#L70">70</a>  			} <strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (name.equalsIgnoreCase(<span class="jxr_string">"String"</span>)) { <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L71" href="#L71">71</a>  				td = <span class="jxr_string">"String"</span>; <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L72" href="#L72">72</a>  			} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L73" href="#L73">73</a>  				td = name.toLowerCase();
<a class="jxr_linenumber" name="L74" href="#L74">74</a>  			}
<a class="jxr_linenumber" name="L75" href="#L75">75</a>  			
<a class="jxr_linenumber" name="L76" href="#L76">76</a>  			<strong class="jxr_keyword">return</strong> td;
<a class="jxr_linenumber" name="L77" href="#L77">77</a>  		}
<a class="jxr_linenumber" name="L78" href="#L78">78</a>  
<a class="jxr_linenumber" name="L79" href="#L79">79</a>  		<strong class="jxr_keyword">return</strong> <span class="jxr_string">""</span>; <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L80" href="#L80">80</a>  	}
<a class="jxr_linenumber" name="L81" href="#L81">81</a>  
<a class="jxr_linenumber" name="L82" href="#L82">82</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L83" href="#L83">83</a>  <em class="jxr_javadoccomment">	 * Return a kind of qualifiedName, except if</em>
<a class="jxr_linenumber" name="L84" href="#L84">84</a>  <em class="jxr_javadoccomment">	 * - The named element has the stereotype External or NoCodeGen</em>
<a class="jxr_linenumber" name="L85" href="#L85">85</a>  <em class="jxr_javadoccomment">	 * - The named element is part of the ANSI C library</em>
<a class="jxr_linenumber" name="L86" href="#L86">86</a>  <em class="jxr_javadoccomment">	 * - The named element is a primitive type that has no further definition via a stereotype (TODO: why is this required/useful?)</em>
<a class="jxr_linenumber" name="L87" href="#L87">87</a>  <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L88" href="#L88">88</a>  <em class="jxr_javadoccomment">	 * @param ne</em>
<a class="jxr_linenumber" name="L89" href="#L89">89</a>  <em class="jxr_javadoccomment">	 * @param ns scope in which ne is used</em>
<a class="jxr_linenumber" name="L90" href="#L90">90</a>  <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L91" href="#L91">91</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L92" href="#L92">92</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> String javaQualifiedName(NamedElement ne, Element ns) {
<a class="jxr_linenumber" name="L93" href="#L93">93</a>  		<strong class="jxr_keyword">if</strong> (ne == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L94" href="#L94">94</a>  			<strong class="jxr_keyword">return</strong> <span class="jxr_string">"undefined"</span>; <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L95" href="#L95">95</a>  		}
<a class="jxr_linenumber" name="L96" href="#L96">96</a>  		Object owner = ne.getOwner();
<a class="jxr_linenumber" name="L97" href="#L97">97</a>  		String owningPkgName = <span class="jxr_string">""</span>; <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L98" href="#L98">98</a>  		<strong class="jxr_keyword">if</strong> (owner instanceof Package) {
<a class="jxr_linenumber" name="L99" href="#L99">99</a>  			owningPkgName = ((Package) owner).getName();
<a class="jxr_linenumber" name="L100" href="#L100">100</a> 		}
<a class="jxr_linenumber" name="L101" href="#L101">101</a> 		<strong class="jxr_keyword">if</strong> (GenUtils.hasStereotype(ne, External.<strong class="jxr_keyword">class</strong>) ||
<a class="jxr_linenumber" name="L102" href="#L102">102</a> 				GenUtils.hasStereotypeTree(ne, NoCodeGen.<strong class="jxr_keyword">class</strong>) ||
<a class="jxr_linenumber" name="L103" href="#L103">103</a> 				GenUtils.hasStereotypeTree(ne, ExternLibrary.<strong class="jxr_keyword">class</strong>)) {
<a class="jxr_linenumber" name="L104" href="#L104">104</a> 			<strong class="jxr_keyword">return</strong> ne.getName();
<a class="jxr_linenumber" name="L105" href="#L105">105</a> 		}
<a class="jxr_linenumber" name="L106" href="#L106">106</a> 		<strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (owningPkgName.equals(JAVA_LIB)) {
<a class="jxr_linenumber" name="L107" href="#L107">107</a> 			<em class="jxr_comment">// always use the short name for types within the ANSI C library</em>
<a class="jxr_linenumber" name="L108" href="#L108">108</a> 			<strong class="jxr_keyword">return</strong> ne.getName();
<a class="jxr_linenumber" name="L109" href="#L109">109</a> 		} <strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (ne instanceof PrimitiveType) {
<a class="jxr_linenumber" name="L110" href="#L110">110</a> 			String stdType = getStdtypes((PrimitiveType) ne);
<a class="jxr_linenumber" name="L111" href="#L111">111</a> 			<strong class="jxr_keyword">if</strong> (!stdType.isEmpty()) {
<a class="jxr_linenumber" name="L112" href="#L112">112</a> 				<strong class="jxr_keyword">return</strong> stdType;
<a class="jxr_linenumber" name="L113" href="#L113">113</a> 			}
<a class="jxr_linenumber" name="L114" href="#L114">114</a> 		}
<a class="jxr_linenumber" name="L115" href="#L115">115</a> 		<strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (owner instanceof ClassifierTemplateParameter) {
<a class="jxr_linenumber" name="L116" href="#L116">116</a> 			<em class="jxr_comment">// return short name for template in Type</em>
<a class="jxr_linenumber" name="L117" href="#L117">117</a> 			<strong class="jxr_keyword">return</strong> ne.getName();
<a class="jxr_linenumber" name="L118" href="#L118">118</a> 		}
<a class="jxr_linenumber" name="L119" href="#L119">119</a> 		
<a class="jxr_linenumber" name="L120" href="#L120">120</a> 		<em class="jxr_comment">// Get qualified name and remove root name if root is a &lt;&lt;Project&gt;&gt;</em>
<a class="jxr_linenumber" name="L121" href="#L121">121</a> 		String qName = GenUtils.getFullName(ne, <span class="jxr_string">"."</span>, false);
<a class="jxr_linenumber" name="L122" href="#L122">122</a> 		
<a class="jxr_linenumber" name="L123" href="#L123">123</a> 		<em class="jxr_comment">// First check that the ne is not a direct inner class of ns</em>
<a class="jxr_linenumber" name="L124" href="#L124">124</a> 		<em class="jxr_comment">// Also check that ne doesnt have the same short name as a direct inner class of ns</em>
<a class="jxr_linenumber" name="L125" href="#L125">125</a> 		<strong class="jxr_keyword">if</strong> (ns instanceof Classifier) {
<a class="jxr_linenumber" name="L126" href="#L126">126</a> 			Classifier classifier = (Classifier) ns;
<a class="jxr_linenumber" name="L127" href="#L127">127</a> 			<strong class="jxr_keyword">for</strong> (Element directlyOwnedElement : classifier.getOwnedElements()) {
<a class="jxr_linenumber" name="L128" href="#L128">128</a> 				<strong class="jxr_keyword">if</strong> (directlyOwnedElement instanceof Enumeration
<a class="jxr_linenumber" name="L129" href="#L129">129</a> 						|| directlyOwnedElement instanceof Interface
<a class="jxr_linenumber" name="L130" href="#L130">130</a> 						|| directlyOwnedElement.eClass().equals(UMLFactory.eINSTANCE.getUMLPackage().getClass_())) {
<a class="jxr_linenumber" name="L131" href="#L131">131</a> 					<strong class="jxr_keyword">if</strong> (((Classifier) directlyOwnedElement).getQualifiedName().equals(ne.getQualifiedName())) {
<a class="jxr_linenumber" name="L132" href="#L132">132</a> 						<strong class="jxr_keyword">return</strong> ne.getName();
<a class="jxr_linenumber" name="L133" href="#L133">133</a> 					} <strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (((Classifier) directlyOwnedElement).getName().equals(ne.getName())) {
<a class="jxr_linenumber" name="L134" href="#L134">134</a> 						<strong class="jxr_keyword">return</strong> qName;
<a class="jxr_linenumber" name="L135" href="#L135">135</a> 					}
<a class="jxr_linenumber" name="L136" href="#L136">136</a> 				}
<a class="jxr_linenumber" name="L137" href="#L137">137</a> 			}
<a class="jxr_linenumber" name="L138" href="#L138">138</a> 		}
<a class="jxr_linenumber" name="L139" href="#L139">139</a> 		
<a class="jxr_linenumber" name="L140" href="#L140">140</a> 		<em class="jxr_comment">// Then check that ne hasn't been imported</em>
<a class="jxr_linenumber" name="L141" href="#L141">141</a> 		EList&lt;String&gt; importsOfCurrentNs = imports.get(currentNE);
<a class="jxr_linenumber" name="L142" href="#L142">142</a> 		<strong class="jxr_keyword">if</strong> (importsOfCurrentNs != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L143" href="#L143">143</a> 			<strong class="jxr_keyword">for</strong> (String importOfCurrentNs : importsOfCurrentNs) {
<a class="jxr_linenumber" name="L144" href="#L144">144</a> 				<strong class="jxr_keyword">if</strong> (importOfCurrentNs.equals(qName)) {
<a class="jxr_linenumber" name="L145" href="#L145">145</a> 					<em class="jxr_comment">// ne is imported in the current ns, so we use its short name</em>
<a class="jxr_linenumber" name="L146" href="#L146">146</a> 					<strong class="jxr_keyword">return</strong> ne.getName();
<a class="jxr_linenumber" name="L147" href="#L147">147</a> 				}
<a class="jxr_linenumber" name="L148" href="#L148">148</a> 			}
<a class="jxr_linenumber" name="L149" href="#L149">149</a> 		}
<a class="jxr_linenumber" name="L150" href="#L150">150</a> 		
<a class="jxr_linenumber" name="L151" href="#L151">151</a> 		<em class="jxr_comment">// We return the qualified name of ne otherwise</em>
<a class="jxr_linenumber" name="L152" href="#L152">152</a> 		<strong class="jxr_keyword">return</strong> qName;		
<a class="jxr_linenumber" name="L153" href="#L153">153</a> 	}
<a class="jxr_linenumber" name="L154" href="#L154">154</a> 
<a class="jxr_linenumber" name="L155" href="#L155">155</a> 
<a class="jxr_linenumber" name="L156" href="#L156">156</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L157" href="#L157">157</a> <em class="jxr_javadoccomment">	 * Returns the string that is used within a Java template declaration, e.g. the "Class XY" in template&lt;class XY&gt;.</em>
<a class="jxr_linenumber" name="L158" href="#L158">158</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L159" href="#L159">159</a> <em class="jxr_javadoccomment">	 * @return the template type formated as string</em>
<a class="jxr_linenumber" name="L160" href="#L160">160</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L161" href="#L161">161</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> String getTemplateTypeName(TemplateParameter templateParam) {
<a class="jxr_linenumber" name="L162" href="#L162">162</a> 		String name = <span class="jxr_string">""</span>; <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L163" href="#L163">163</a> 
<a class="jxr_linenumber" name="L164" href="#L164">164</a> 		<em class="jxr_comment">// Retrieve name of the ParameteredElement (when possible = it is a NamedElement</em>
<a class="jxr_linenumber" name="L165" href="#L165">165</a> 		ParameterableElement pElt = templateParam.getParameteredElement();
<a class="jxr_linenumber" name="L166" href="#L166">166</a> 		<strong class="jxr_keyword">if</strong> ((pElt != <strong class="jxr_keyword">null</strong>) &amp;&amp; (pElt instanceof NamedElement)) {
<a class="jxr_linenumber" name="L167" href="#L167">167</a> 			name = ((NamedElement) pElt).getName();
<a class="jxr_linenumber" name="L168" href="#L168">168</a> 		} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L169" href="#L169">169</a> 			name = <span class="jxr_string">"undefined"</span>; <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L170" href="#L170">170</a> 		}
<a class="jxr_linenumber" name="L171" href="#L171">171</a> 
<a class="jxr_linenumber" name="L172" href="#L172">172</a> 		<strong class="jxr_keyword">return</strong> (name);
<a class="jxr_linenumber" name="L173" href="#L173">173</a> 	}
<a class="jxr_linenumber" name="L174" href="#L174">174</a> 
<a class="jxr_linenumber" name="L175" href="#L175">175</a> 
<a class="jxr_linenumber" name="L176" href="#L176">176</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L177" href="#L177">177</a> <em class="jxr_javadoccomment">	 * Return a Java namespace definition for a named element</em>
<a class="jxr_linenumber" name="L178" href="#L178">178</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L179" href="#L179">179</a> <em class="jxr_javadoccomment">	 * @param ne</em>
<a class="jxr_linenumber" name="L180" href="#L180">180</a> <em class="jxr_javadoccomment">	 *            a named element</em>
<a class="jxr_linenumber" name="L181" href="#L181">181</a> <em class="jxr_javadoccomment">	 * @return a Java namespace definition for a named element</em>
<a class="jxr_linenumber" name="L182" href="#L182">182</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L183" href="#L183">183</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> String getNamespace(NamedElement ne) {
<a class="jxr_linenumber" name="L184" href="#L184">184</a> 		String namespace = <span class="jxr_string">""</span>; <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L185" href="#L185">185</a> 		<strong class="jxr_keyword">for</strong> (Namespace ns : ne.allNamespaces()) {
<a class="jxr_linenumber" name="L186" href="#L186">186</a> 			<strong class="jxr_keyword">if</strong> (ns.getOwner() != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L187" href="#L187">187</a> 				String nsName = ns.getName();
<a class="jxr_linenumber" name="L188" href="#L188">188</a> 				<strong class="jxr_keyword">if</strong> (!namespace.equals(<span class="jxr_string">""</span>)) { <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L189" href="#L189">189</a> 					nsName += <span class="jxr_string">"::"</span>; <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L190" href="#L190">190</a> 				}
<a class="jxr_linenumber" name="L191" href="#L191">191</a> 				namespace = nsName + namespace;
<a class="jxr_linenumber" name="L192" href="#L192">192</a> 			}
<a class="jxr_linenumber" name="L193" href="#L193">193</a> 		}
<a class="jxr_linenumber" name="L194" href="#L194">194</a> 		<strong class="jxr_keyword">if</strong> (!namespace.equals(<span class="jxr_string">""</span>)) { <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L195" href="#L195">195</a> 			namespace = <span class="jxr_string">"\n"</span> + <span class="jxr_string">"using namespace "</span> + namespace + <span class="jxr_string">";\n"</span>; <em class="jxr_comment">//$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$</em>
<a class="jxr_linenumber" name="L196" href="#L196">196</a> 		}
<a class="jxr_linenumber" name="L197" href="#L197">197</a> 		<strong class="jxr_keyword">return</strong> namespace;
<a class="jxr_linenumber" name="L198" href="#L198">198</a> 	}
<a class="jxr_linenumber" name="L199" href="#L199">199</a> 
<a class="jxr_linenumber" name="L200" href="#L200">200</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L201" href="#L201">201</a> <em class="jxr_javadoccomment">	 * Update the currentNS (used to organize imports and types)</em>
<a class="jxr_linenumber" name="L202" href="#L202">202</a> <em class="jxr_javadoccomment">	 * @param ne</em>
<a class="jxr_linenumber" name="L203" href="#L203">203</a> <em class="jxr_javadoccomment">	 *            a named element</em>
<a class="jxr_linenumber" name="L204" href="#L204">204</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L205" href="#L205">205</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">void</strong> openNS(NamedElement ne) {
<a class="jxr_linenumber" name="L206" href="#L206">206</a> 		currentNE = ne;
<a class="jxr_linenumber" name="L207" href="#L207">207</a> 		currentNS = ne.getNamespace();
<a class="jxr_linenumber" name="L208" href="#L208">208</a> 	}
<a class="jxr_linenumber" name="L209" href="#L209">209</a> }
</pre>
<hr/>
<div id="footer">Copyright &#169; 2016 <a href="https://www.eclipse.org/">Eclipse foundation</a>. All rights reserved.</div>
</body>
</html>
